<?php
	
	//include('ELO_code.php');
	include('correlation.php');
	
	//include('database.php');
	//DB_connexion(); 
	
	
/******************************************/
function lire_csv($nom_fichier )
{
    $donnee = array();   
	$joueur = array();
	$table_csv = array();
	
	$file = fopen ($nom_fichier,"r");
		
	while(! feof($file))
	{
			$tmp = fgets($file);
			$tmp = strtolower($tmp);
			//echo $tmp ."<BR>";
			$tmp = str_to_noaccent($tmp);
			$pieces = explode(";", $tmp);
			if($pieces[1] != "")
			{
				$table_csv[] = $pieces;
				$joueur[] = $pieces[1];
				$joueur[] = $pieces[2];
			}
	}
	
	fclose($file);
	
	$nb_ligne = count($table_csv);
	
	for ($i=0; $i < $nb_ligne; $i++)
	{
			$val = $table_csv[$i][4];
			$position = strpos($val, "5");
			if($position !== false)
			{ 
				//echo " Match nul";
				//echo "<br>";
				$table_csv[$i][3] = "0.5";
				$table_csv[$i][4] = "0.5";
			}
	
			$date_partie = $table_csv[$i][0];
			if($date_partie != "")
			{	$date = mise_en_forme_date($date_partie);
				$sauve = $date;
				$table_csv[$i][0] = $date;
			}
			else
			{	$table_csv[$i][0] = $sauve; 
			}
			
	}	
	
	
	$sans_doublon = array_unique($joueur);
	$sans_doublon = array_values($sans_doublon);
	// ordonner par ordre alphabetique
	usort($sans_doublon, "strcasecmp");
	$merge = array($table_csv, $sans_doublon );
	echo "<pre>";
	print_r($merge);
	
	return $merge;
	
}
/******************************************/
function str_to_noaccent($str)
{
    $tmp = $str;
    $tmp = preg_replace('#Ç#', 'C', $tmp);
    $tmp = preg_replace('#ç#', 'c', $tmp);
    $tmp = preg_replace('#è|é|ê|ë#', 'e', $tmp);
    $tmp = preg_replace('#È|É|Ê|Ë#', 'E', $tmp);
    $tmp = preg_replace('#à|á|â|ã|ä|å#', 'a', $tmp);
    $tmp = preg_replace('#@|À|Á|Â|Ã|Ä|Å#', 'A', $tmp);
    $tmp = preg_replace('#ì|í|î|ï#', 'i', $tmp);
    $tmp = preg_replace('#Ì|Í|Î|Ï#', 'I', $tmp);
    $tmp = preg_replace('#ð|ò|ó|ô|õ|ö#', 'o', $tmp);
    $tmp = preg_replace('#Ò|Ó|Ô|Õ|Ö#', 'O', $tmp);
    $tmp = preg_replace('#ù|ú|û|ü#', 'u', $tmp);
    $tmp = preg_replace('#Ù|Ú|Û|Ü#', 'U', $tmp);
    $tmp = preg_replace('#ý|ÿ#', 'y', $tmp);
    $tmp = preg_replace('#Ý#', 'Y', $tmp);
     
    return ($tmp);
}
/******************************************/
function mise_en_forme_date($date)
{
		list($jour, $mois, $annee) = explode('/', $date);
		$timestamp = mktime (0, 0, 0, $mois, $jour, $annee);
		return($timestamp);
}
/******************************************/
function stockage_joueurs_DB($donnees)
{
			$elo = 1000;
			$i = 0;
			$nb_ligne =  count($donnees);
			
			for ($i=0; $i < $nb_ligne; $i++)
			{

				$prenom = $donnees[$i];
				$partie = 0;
				$prior = 0;
			
				// verifier que le joueur n'existe pas dans la database
				$sql = "select joueur from classement where joueur = '$prenom' ";
				$result = mysql_query($sql);
				if(mysql_num_rows($result)>=1)
				{
						echo "Ce joueur existe déjà :" .$prenom;
						echo "<br>";
				}
		
				else
				{
/*
Henrique: 1300

Fabien: 1300

Domi: 1100

Remy: 1100

StephaneR: 1000

Laurent: 1200

Damien : 1000

FranckDC : 1000

FranckV : 1000

Bordi : 1000

Amokrane : 1050

Causse : 1250

StephB : 1000

Patrick : 1000

Clou :950

Emile :850

Joel :950

Alex:750
			*/	
					if($prenom == "henrique")
					{
						$elo = 1300;
					}
					if($prenom == "fabien")
					{
						$elo = 1300;
					}
					if($prenom == "dominique")
					{
						$elo = 1100;
					}
					if($prenom == "remy")
					{
						$elo = 1100;
					}
					if($prenom == "stephaner")
					{
						$elo = 1000;
					}
					if($prenom == "laurent")
					{
						$elo = 1200;
					}
					if($prenom == "damien")
					{
						$elo = 1000;
					}
					if($prenom == "franckdc")
					{
						$elo = 1000;
					}
					if($prenom == "franckv")
					{
						$elo = 1000;
					}
					if($prenom == "bordi")
					{
						$elo = 1000;
					}
					if($prenom == "amokrane")
					{
						$elo = 1050;
					}
					if($prenom == "olivier")
					{
						$elo = 1250;
					}
					if($prenom == "stephaneb")
					{
						$elo = 1000;
					}
					
					if($prenom == "patrick")
					{
						$elo = 1000;
					}
					if($prenom == "bertrand")
					{
						$elo = 950;
					}
					if($prenom == "emile")
					{
						$elo = 850;
					}
					
					if($prenom =="joel")
					{
						$elo = 950;
					}
					if($prenom == "alexandre")
					{
						$elo = 750;
					}
				
					$sql = " INSERT INTO classement ";
					$sql = $sql . " (joueur, elo, parties, prior, initial) VALUES ";
					$sql = $sql . " ('$prenom', '$elo','$partie','$prior', '$elo') ";
					echo $sql;
					echo "<br>";
					$result = mysql_query($sql);
					if (!$result)
					{ 
						echo("ERROR: " . mysql_error() . "\n$SQL\n");	
					}
				}	
			}	
}		
	
/******************************************/
function import_donnees($fichier)
{
	$donnees = lire_csv($fichier);
	
	// fragmentation
	$liste_parties = array();
	$liste_joueurs = array();
	$liste_parties = $donnees[0];
	$liste_joueurs = $donnees[1]; 
	// affichage
	echo " ------------------------------" ."<br>";
	echo "<pre>";
	print_r($liste_parties);
	echo "<br>";
	echo " ------------------------------" ."<br>";
	echo "<pre>";
	print_r($liste_joueurs);

	mysql_query('TRUNCATE TABLE classement;');
	mysql_query('TRUNCATE TABLE evolution;');
	mysql_query('TRUNCATE TABLE games;');
	mysql_query('TRUNCATE TABLE parties;');
	mysql_query('TRUNCATE TABLE rating;');

	echo "<br>";
	echo " ------------------------------" ."<br>";
	// enregistrer 
	stockage_joueurs_DB($liste_joueurs);
	echo "<br>";
	echo " ------------------------------" ."<br>";
	// calculer du classement
	
	$nb_parties = count($liste_parties);
	
	for ($item=0; $item < $nb_parties ; $item++)
	{
			$donnees[0] = $liste_parties[$item][0];
			$donnees[1] = $liste_parties[$item][1];
			$donnees[2] = $liste_parties[$item][2];
			$donnees[3] = $liste_parties[$item][3];
			$donnees[4] = $liste_parties[$item][4];
			
			$indice = $item + 1;
			
			algo_elo($donnees, "statistique", "sql", $indice );
	
	}
	
	/*
	switch ($_SESSION['algorithme']) 
	{
			case "un":
					traitement_classement_elo_un($liste_parties);
					break;
			case "deux":
					traitement_classement_elo_deux($liste_parties);
					break;
				default:
					echo "erreur dans le traitement";
	}*/

	echo "<br>";
	echo " ------------------------------" ."<br>";

	echo "Script executé avec succés";	
	echo "<br>";
	
}		
/******************************************/
	
	import_donnees("elo.csv");
?>